﻿using System;
using GrapeCity.Documents.Excel;
using Microsoft.Extensions.Configuration.Json;
using Microsoft.Extensions.Logging.Abstractions;
using Microsoft.Extensions.Logging.Console;
using Serilog.Extensions.Logging.File;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using System.IO;
using Serilog;
using Serilog.Configuration;
using Serilog.Events;
using System.Drawing;

class Functions
    {

        static void Main(string[] args)
        {
            //source data
            object[,] sourceData = new object[,] {
            { "Current AQI", "City", "Country"},
            
            { 31, "Oklahoma City","US"},
            { 5, "New York City","US"},
            { 101, "Philadelphia","US"},
            { 76, "Washington",  "US"},
            { 25, "London",  "United Kingdom"},
            { 148, "New Delhi",  "India"},
            { 35, "Tokyo",  "Japan"},
            { 174, "Beijing",  "China"},
            { 45, "Canberra",  "Australia"},
            { 56, "Rome", "Italy"},
            { 305, "Hanoi", "Vietnam"},
            { 161, "Doha", "Qatar"},
            { 209, "Dhaka","Bangladesh"}
            
            };

            //add source data in Sheet1
            var workbook = new GrapeCity.Documents.Excel.Workbook();
            IWorksheet worksheet = workbook.Worksheets[0];
            worksheet.Name = "Data";
            worksheet.Range["A1:C14"].Value = sourceData;
            worksheet.Range["A1:C18"].Columns.AutoFit();
            worksheet.Range["A1:C18"].Rows.AutoFit();

            //add new worksheet
            workbook.Worksheets.AddAfter(worksheet);

            //invoke methods from Concat_Switch class to apply functions
            Concat_Switch cs = new Concat_Switch();

            cs.ConcatFn(workbook);
            cs.SwitchFn(workbook);
            cs.MaxMinFn(workbook);
            cs.ConditionalFormatting(workbook);

            //add new worksheet
            IWorksheet worksheet1 = workbook.Worksheets.AddAfter(worksheet);

            //invoke methods from Textjoin_Ifs class to apply functions
            Textjoin_Ifs ff = new Textjoin_Ifs();
            ff.TextjoinFn(workbook);
            ff.IfsFn(workbook);
            ff.MaxMinFn(workbook);
            ff.ConditionalFormatting(workbook);

            //save workbook
            workbook.Save("AQI_Report.xlsx");

            Console.WriteLine("\n----Excel created----");
            Console.ReadLine();
        }
        // Wait for the user to respond before closing   
    }
