﻿using System;
using GrapeCity.Documents.Excel;
using GrapeCity.Documents.Text;
using Microsoft.Extensions.Configuration.Json;
using Microsoft.Extensions.Logging.Abstractions;
using Microsoft.Extensions.Logging.Console;
using Serilog.Extensions.Logging.File;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using System.IO;
using Serilog;
using Serilog.Configuration;
using Serilog.Events;
using System.Drawing;

class Textjoin_Ifs
{   
    public void TextjoinFn(Workbook workbook)
    {       
        //new worksheet
        IWorksheet worksheet1 = workbook.Worksheets[1];
        worksheet1.Name = "TEXTJOIN&IFS";
        IRange rangeA1 = worksheet1.Range["A1"];
        worksheet1.Range["A1:C1"].Merge();
        worksheet1.Range["A1"].Value = "AQI Report";
        worksheet1.Range["A1"].Font.Bold = true;
        worksheet1.Range["A1"].Font.Size = 18;
        worksheet1.Range["A1"].Interior.Color = Color.LightGray;
        rangeA1.HorizontalAlignment = HorizontalAlignment.Center;

        //column headers
        worksheet1.Range["A3"].Value = "Location";
        worksheet1.Range["B3"].Value = "Current AQI";
        worksheet1.Range["C3"].Value = "Level Of Health Concern";
        worksheet1.Range["A3:C3"].Font.Bold = true;
        worksheet1.Range["A1"].Font.Size = 15;

        //TEXTJOIN in column A
        worksheet1.Range["A4"].Formula = "=TEXTJOIN(\", \", true, Data!B2, Data!C2)";
        worksheet1.Range["A5"].Formula = "=TEXTJOIN(\", \", true, Data!B3, Data!C3 )";
        worksheet1.Range["A6"].Formula = "=TEXTJOIN(\", \", true, Data!B4, Data!C4 )";
        worksheet1.Range["A7"].Formula = "=TEXTJOIN(\", \", true, Data!B5, Data!C5 )";
        worksheet1.Range["A8"].Formula = "=TEXTJOIN(\", \", true, Data!B6, Data!C6 )";
        worksheet1.Range["A9"].Formula = "=TEXTJOIN(\", \", true, Data!B7, Data!C7 )";
        worksheet1.Range["A10"].Formula = "=TEXTJOIN(\", \", true, Data!B8, Data!C8 )";
        worksheet1.Range["A11"].Formula = "=TEXTJOIN(\", \", true, Data!B9, Data!C9 )";
        worksheet1.Range["A12"].Formula = "=TEXTJOIN(\", \", true, Data!B10, Data!C10 )";
        worksheet1.Range["A13"].Formula = "=TEXTJOIN(\", \", true, Data!B11, Data!C11 )";
        worksheet1.Range["A14"].Formula = "=TEXTJOIN(\", \", true, Data!B12, Data!C12 )";
        worksheet1.Range["A15"].Formula = "=TEXTJOIN(\", \", true, Data!B13, Data!C13 )";
        worksheet1.Range["A16"].Formula = "=TEXTJOIN(\", \", true, Data!B14, Data!C14 )";

        //AQI values
        worksheet1.Range["B4"].Formula = "=Data!A2";
        worksheet1.Range["B5"].Formula = "=Data!A3";
        worksheet1.Range["B6"].Formula = "=Data!A4";
        worksheet1.Range["B7"].Formula = "=Data!A5";
        worksheet1.Range["B8"].Formula = "=Data!A6";
        worksheet1.Range["B9"].Formula = "=Data!A7";
        worksheet1.Range["B10"].Formula = "=Data!A8";
        worksheet1.Range["B11"].Formula = "=Data!A9";
        worksheet1.Range["B12"].Formula = "=Data!A10";
        worksheet1.Range["B13"].Formula = "=Data!A11";
        worksheet1.Range["B14"].Formula = "=Data!A12";
        worksheet1.Range["B15"].Formula = "=Data!A13";
        worksheet1.Range["B16"].Formula = "=Data!A14";

        worksheet1.Range["A1:C18"].Columns.AutoFit();
        worksheet1.Range["A1:C18"].Rows.AutoFit();
      
    }

    public void IfsFn(Workbook workbook)
    {        
             IWorksheet worksheet1 = workbook.Worksheets[1];        
            //IFS in column C
            worksheet1.Range["C4"].Formula = "=IFS(B4>300, \"Hazardous\", B4>200, \"Very Unhealthy\", B4>150, \"Unhealthy\", B4>100, \"Moderate\", B4>50, \"Satisfactory\", B4<=50, \"Good\")";
            worksheet1.Range["C5"].Formula = "=IFS(B5>300, \"Hazardous\", B5>200, \"Very Unhealthy\", B5>150, \"Unhealthy\", B5>100, \"Moderate\", B5>50, \"Satisfactory\", B5<=50, \"Good\")";
            worksheet1.Range["C6"].Formula = "=IFS(B6>300, \"Hazardous\", B6>200, \"Very Unhealthy\", B6>150, \"Unhealthy\", B6>100, \"Moderate\", B6>50, \"Satisfactory\", B6<=50, \"Good\")";
            worksheet1.Range["C7"].Formula = "=IFS(B7>300, \"Hazardous\", B7>200, \"Very Unhealthy\", B7>150, \"Unhealthy\", B7>100, \"Moderate\", B7>50, \"Satisfactory\", B7<=50, \"Good\")";
            worksheet1.Range["C8"].Formula = "=IFS(B8>300, \"Hazardous\", B8>200, \"Very Unhealthy\", B8>150, \"Unhealthy\", B8>100, \"Moderate\", B8>50, \"Satisfactory\", B8<=50, \"Good\")";
            worksheet1.Range["C9"].Formula = "=IFS(B9>300, \"Hazardous\", B9>200, \"Very Unhealthy\", B9>150, \"Unhealthy\", B9>100, \"Moderate\", B9>50, \"Satisfactory\", B9<=50, \"Good\")";
            worksheet1.Range["C10"].Formula = "=IFS(B10>300, \"Hazardous\", B10>200, \"Very Unhealthy\", B10>150, \"Unhealthy\", B10>100, \"Moderate\", B10>50, \"Satisfactory\", B10<=50, \"Good\")";
            worksheet1.Range["C11"].Formula = "=IFS(B11>300, \"Hazardous\", B11>200, \"Very Unhealthy\", B11>150, \"Unhealthy\", B11>100, \"Moderate\", B11>50, \"Satisfactory\", B11<=50, \"Good\")";
            worksheet1.Range["C12"].Formula = "=IFS(B12>300, \"Hazardous\", B12>200, \"Very Unhealthy\", B12>150, \"Unhealthy\", B12>100, \"Moderate\", B12>50, \"Satisfactory\", B12<=50, \"Good\")";
            worksheet1.Range["C13"].Formula = "=IFS(B13>300, \"Hazardous\", B13>200, \"Very Unhealthy\", B13>150, \"Unhealthy\", B13>100, \"Moderate\", B13>50, \"Satisfactory\", B13<=50, \"Good\")";
            worksheet1.Range["C14"].Formula = "=IFS(B14>300, \"Hazardous\", B14>200, \"Very Unhealthy\", B14>150, \"Unhealthy\", B14>100, \"Moderate\", B14>50, \"Satisfactory\", B14<=50, \"Good\")";
            worksheet1.Range["C15"].Formula = "=IFS(B15>300, \"Hazardous\", B15>200, \"Very Unhealthy\", B15>150, \"Unhealthy\", B15>100, \"Moderate\", B15>50, \"Satisfactory\", B15<=50, \"Good\")";
            worksheet1.Range["C16"].Formula = "=IFS(B16>300, \"Hazardous\", B16>200, \"Very Unhealthy\", B16>150, \"Unhealthy\", B16>100, \"Moderate\", B16>50, \"Satisfactory\", B16<=50, \"Good\")";
    }

    public void MaxMinFn(Workbook workbook)
    {       
        IWorksheet worksheet1 = workbook.Worksheets[1];      
        //column headers
        worksheet1.Range["A20"].Value = "US City with Worst  AQI";
		worksheet1.Range["A21"].Value = "US City with Best  AQI";

        //MAXIFS and MINIFS
        worksheet1.Range["B20"].Formula = "=INDEX(Data!B2:B14, MATCH(MAXIFS(Data!A2:A14,Data!C2:C14,\"US\"),Data!A2:A14,0))";
        worksheet1.Range["B21"].Formula = "=INDEX(Data!B2:B14, MATCH(MINIFS(Data!A2:A14,Data!C2:C14,\"US\"),Data!A2:A14,0))";

    }

    public void ConditionalFormatting(Workbook workbook)
    {       
        IWorksheet worksheet1 = workbook.Worksheets[1];
        //conditional formatting
        IFormatCondition condition = worksheet1.Range["A4:C16"].FormatConditions.Add(FormatConditionType.Expression, FormatConditionOperator.None, "=$B4>300") as IFormatCondition;
        condition.Interior.Color = Color.FromArgb(175, 45, 36);
        IFormatCondition condition2 = worksheet1.Range["A4:C16"].FormatConditions.Add(FormatConditionType.Expression, FormatConditionOperator.None, "=AND($B4>=201,$B4<=300)") as IFormatCondition;
        condition2.Interior.Color = Color.FromArgb(1, 167, 86, 177);
        IFormatCondition condition3 = worksheet1.Range["A4:C16"].FormatConditions.Add(FormatConditionType.Expression, FormatConditionOperator.None, "=AND($B4>=151,$B4<=200)") as IFormatCondition;
        condition3.Interior.Color = Color.FromArgb(233, 63, 51);
        IFormatCondition condition4 = worksheet1.Range["A4:C16"].FormatConditions.Add(FormatConditionType.Expression, FormatConditionOperator.None, "=AND($B4>=101,$B4<=150)") as IFormatCondition;
        condition4.Interior.Color = Color.FromArgb(242, 156, 51);
        IFormatCondition condition5 = worksheet1.Range["A4:C16"].FormatConditions.Add(FormatConditionType.Expression, FormatConditionOperator.None, "=AND($B4>=51,$B4<=100)") as IFormatCondition;
        condition5.Interior.Color = Color.FromArgb(1, 255, 249, 74);
        IFormatCondition condition6 = worksheet1.Range["A4:C16"].FormatConditions.Add(FormatConditionType.Expression, FormatConditionOperator.None, "=AND($B4>=0,$B4<=50)") as IFormatCondition;
        condition6.Interior.Color = Color.FromArgb(85, 168, 79);

        worksheet1.Range["A1:C21"].Columns.AutoFit();
        worksheet1.Range["A1:C21"].Rows.AutoFit();

    } 

}
